# Junit Xray

This package permit to link [JUnit 5](https://junit.org/) or [TestNG](https://testng.org) tests to [Xray](https://www.getxray.app/) tests and upload results to Xray.

The most important issue with actual Xray/Xunit integration is we can't know witch US is covered by actual junit tests. This library is here to resolve this issue.
With junit-xray you can now have this behavior driven development (BDD) workflow : 

```mermaid
graph LR
  subgraph Prepare the User Story
    WriteUS["Write US"] --> Discovery
    Discovery --> Formulation
  end
  Formulation --> Automation
  subgraph Implement the User Story
    Automation --> RunDev["Run tests on developer decktop"]
    RunDev --> CI["Continuous Integration"]
    CI --> Release
  end
  Release --> TestIRL
  subgraph Validation
    TestIRL --> Deploy["Deploy on hardware"]
  end
```

* PO write the user story.
* BDD 3 amigos (PO, Dev, QA) write tests in xray during refinement steps (discovery and formulation) and they attach tests to the User Story. 
* Dev takes the US and implement all tests attached to the US in JUnit or TestNG. He links each Xray tests with one unit test.
* Each execution results of test (on the developer desktop and in the CI) are upload to Xray, every one can know the test coverage of US in Xray, (see figure 1 for sample coverage report).
* When the software is released, QA can play Xray test manually with real hardware before deployment in production.

This library is compatible with java 1.8 and be used in Android project.

<figure>
  <img src="/doc/sample-coverage-report.png" alt="Sample coverage report" />
  <figcaption>Figure 1: Sample coverage report</figcaption>
</figure>

# How to use

* ⚠️ This version can only upload test result to Xray Cloud
* ⚠️ You must launch your tests with JUnit 5 engine or TestNG runner, if you have JUnit 3 or 4 tests, use [junit-vintage-engine](https://junit.org/junit5/docs/current/user-guide/#migrating-from-junit4-running)

## In Xray 

You must have some "Project Test Environments" defined in Xray Settings : 

* one environment name "development"
* if you run tests on gitlab, one environment named "gitlab"
* if you run tests on jenkins, one environment named "jenkins"

The user associated with client_id and client_secret must have the right to create test execution.

## In your running test environment

You must setup environment variables to have a working upload :

* XRAY_CLIENT_ID
* XRAY_CLIENT_SECRET

client_id and client_secret can be generated by administrator in screen [Global Settings: API Keys](https://confluence.xpand-it.com/display/XRAYCLOUD/Global+Settings%3A+API+Keys)

## In your code

Add the dependency in your `pom.xml`:

```xml
<dependency>
  <groupId>net.azae.xray</groupId>
  <artifactId>junit-xray</artifactId>
  <version>1.1.0</version>
</dependency>
```

And add the Xray annotation to your test to link it to the xray test.

```java
@Test
@Xray("ID-OF-TEST")
void should_report_xray_id_and_status_passed() {
    assertTrue(true);
}
```

### JUnit 5

To use the Listener: add file `META-INF/services/org.junit.platform.launcher.TestExecutionListener` with the content `net.azae.xray.junit5.XrayListener` in your classpath like [TestExecutionListener](/src/main/resources/META-INF/services/org.junit.platform.launcher.TestExecutionListener)

### TestNG

To use the Listener, add annotation on your test class like :

```java
import net.azae.xray.testng.XrayListener;

@Listeners({XrayListener.class})
public class TestNgIntegrationTest {
...
```

# How to release a new version

```
mvn versions:set -DnewVersion=1.0.O
mvn clean deploy -P release
git tag "1.0.0"
mvn versions:set -DnewVersion=1.1.O-SNAPSHOT

```
